Index: src/project.c
===================================================================
--- src/project.c	(revision 2039)
+++ src/project.c	(working copy)
@@ -47,7 +47,7 @@
 
 static struct
 {
-	gchar *project_file_path; // in UTF-8
+    gchar *project_file_path; // in UTF-8
 } local_prefs = {NULL};
 
 
@@ -56,13 +56,13 @@
 // simple struct to keep references to the elements of the properties dialog
 typedef struct _PropertyDialogElements
 {
-	GtkWidget *dialog;
-	GtkWidget *name;
-	GtkWidget *description;
-	GtkWidget *file_name;
-	GtkWidget *base_path;
-	GtkWidget *run_cmd;
-	GtkWidget *patterns;
+    GtkWidget *dialog;
+    GtkWidget *name;
+    GtkWidget *description;
+    GtkWidget *file_name;
+    GtkWidget *base_path;
+    GtkWidget *run_cmd;
+    GtkWidget *patterns;
 } PropertyDialogElements;
 
 
@@ -87,404 +87,419 @@
 
 void project_new()
 {
-	GtkWidget *vbox;
-	GtkWidget *table;
-	GtkWidget *image;
-	GtkWidget *button;
-	GtkWidget *bbox;
-	GtkWidget *label;
-	GtkTooltips *tooltips = GTK_TOOLTIPS(lookup_widget(app->window, "tooltips"));
-	PropertyDialogElements *e;
-	gint response;
+    GtkWidget *vbox;
+    GtkWidget *table;
+    GtkWidget *image;
+    GtkWidget *button;
+    GtkWidget *bbox;
+    GtkWidget *label;
+    GtkTooltips *tooltips = GTK_TOOLTIPS(lookup_widget(app->window, "tooltips"));
+    PropertyDialogElements *e;
+    gint response;
 
-	if (! close_open_project()) return;
+    if (! close_open_project()) return;
 
-	g_return_if_fail(app->project == NULL);
+    g_return_if_fail(app->project == NULL);
 
-	e = g_new0(PropertyDialogElements, 1);
-	e->dialog = gtk_dialog_new_with_buttons(_("New Project"), GTK_WINDOW(app->window),
-										 GTK_DIALOG_DESTROY_WITH_PARENT,
-										 GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
+    e = g_new0(PropertyDialogElements, 1);
+    e->dialog = gtk_dialog_new_with_buttons(_("New Project"), GTK_WINDOW(app->window),
+                                         GTK_DIALOG_DESTROY_WITH_PARENT,
+                                         GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
 
-	gtk_widget_set_name(e->dialog, "GeanyDialogProject");
-	bbox = gtk_hbox_new(FALSE, 0);
-	button = gtk_button_new();
-	image = gtk_image_new_from_stock("gtk-new", GTK_ICON_SIZE_BUTTON);
-	label = gtk_label_new_with_mnemonic(_("C_reate"));
-	gtk_box_pack_start(GTK_BOX(bbox), image, FALSE, FALSE, 3);
-	gtk_box_pack_start(GTK_BOX(bbox), label, FALSE, FALSE, 3);
-	gtk_container_add(GTK_CONTAINER(button), bbox);
-	gtk_dialog_add_action_widget(GTK_DIALOG(e->dialog), button, GTK_RESPONSE_OK);
+    gtk_widget_set_name(e->dialog, "GeanyDialogProject");
+    bbox = gtk_hbox_new(FALSE, 0);
+    button = gtk_button_new();
+    image = gtk_image_new_from_stock("gtk-new", GTK_ICON_SIZE_BUTTON);
+    label = gtk_label_new_with_mnemonic(_("C_reate"));
+    gtk_box_pack_start(GTK_BOX(bbox), image, FALSE, FALSE, 3);
+    gtk_box_pack_start(GTK_BOX(bbox), label, FALSE, FALSE, 3);
+    gtk_container_add(GTK_CONTAINER(button), bbox);
+    gtk_dialog_add_action_widget(GTK_DIALOG(e->dialog), button, GTK_RESPONSE_OK);
 
-	vbox = ui_dialog_vbox_new(GTK_DIALOG(e->dialog));
+    vbox = ui_dialog_vbox_new(GTK_DIALOG(e->dialog));
 
-	entries_modified = FALSE;
+    entries_modified = FALSE;
 
-	table = gtk_table_new(3, 2, FALSE);
-	gtk_table_set_row_spacings(GTK_TABLE(table), 5);
-	gtk_table_set_col_spacings(GTK_TABLE(table), 10);
+    table = gtk_table_new(3, 2, FALSE);
+    gtk_table_set_row_spacings(GTK_TABLE(table), 5);
+    gtk_table_set_col_spacings(GTK_TABLE(table), 10);
 
-	label = gtk_label_new(_("Name:"));
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Name:"));
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->name = gtk_entry_new();
-	gtk_entry_set_max_length(GTK_ENTRY(e->name), MAX_NAME_LEN);
+    e->name = gtk_entry_new();
+    gtk_entry_set_max_length(GTK_ENTRY(e->name), MAX_NAME_LEN);
 
-	ui_table_add_row(GTK_TABLE(table), 0, label, e->name, NULL);
+    ui_table_add_row(GTK_TABLE(table), 0, label, e->name, NULL);
 
-	label = gtk_label_new(_("Filename:"));
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Filename:"));
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->file_name = gtk_entry_new();
-	gtk_entry_set_width_chars(GTK_ENTRY(e->file_name), 30);
-	button = gtk_button_new();
-	g_signal_connect((gpointer) button, "clicked",
-				G_CALLBACK(on_file_save_button_clicked), e->file_name);
-	image = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_BUTTON);
-	gtk_container_add(GTK_CONTAINER(button), image);
-	bbox = gtk_hbox_new(FALSE, 6);
-	gtk_box_pack_start_defaults(GTK_BOX(bbox), e->file_name);
-	gtk_box_pack_start(GTK_BOX(bbox), button, FALSE, FALSE, 0);
+    e->file_name = gtk_entry_new();
+    gtk_entry_set_width_chars(GTK_ENTRY(e->file_name), 30);
+    button = gtk_button_new();
+    g_signal_connect((gpointer) button, "clicked",
+                G_CALLBACK(on_file_save_button_clicked), e->file_name);
+    image = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_BUTTON);
+    gtk_container_add(GTK_CONTAINER(button), image);
+    bbox = gtk_hbox_new(FALSE, 6);
+    gtk_box_pack_start_defaults(GTK_BOX(bbox), e->file_name);
+    gtk_box_pack_start(GTK_BOX(bbox), button, FALSE, FALSE, 0);
 
-	ui_table_add_row(GTK_TABLE(table), 1, label, bbox, NULL);
+    ui_table_add_row(GTK_TABLE(table), 1, label, bbox, NULL);
 
-	label = gtk_label_new(_("Base path:"));
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Base path:"));
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->base_path = gtk_entry_new();
-	gtk_tooltips_set_tip(tooltips, e->base_path,
-		_("Base directory of all files that make up the project. "
-		"This can be a new path, or an existing directory tree absolute "
-		"or relative to the project filename."), NULL);
-	bbox = ui_path_box_new(_("Choose Project Base Path"),
-		GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(e->base_path));
+    e->base_path = gtk_entry_new();
+    gtk_tooltips_set_tip(tooltips, e->base_path,
+        _("Base directory of all files that make up the project. "
+        "This can be a new path, or an existing directory tree absolute "
+        "or relative to the project filename."), NULL);
+    bbox = ui_path_box_new(_("Choose Project Base Path"),
+        GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(e->base_path));
 
-	ui_table_add_row(GTK_TABLE(table), 2, label, bbox, NULL);
+    ui_table_add_row(GTK_TABLE(table), 2, label, bbox, NULL);
 
-	gtk_container_add(GTK_CONTAINER(vbox), table);
+    gtk_container_add(GTK_CONTAINER(vbox), table);
 
-	// signals
-	g_signal_connect((gpointer) e->name, "changed", G_CALLBACK(on_name_entry_changed), e);
-	// run the callback manually to initialise the base_path and file_name fields
-	on_name_entry_changed(GTK_EDITABLE(e->name), e);
+    // signals
+    g_signal_connect((gpointer) e->name, "changed", G_CALLBACK(on_name_entry_changed), e);
+    // run the callback manually to initialise the base_path and file_name fields
+    on_name_entry_changed(GTK_EDITABLE(e->name), e);
 
-	g_signal_connect((gpointer) e->file_name, "changed", G_CALLBACK(on_entries_changed), e);
-	g_signal_connect((gpointer) e->base_path, "changed", G_CALLBACK(on_entries_changed), e);
+    g_signal_connect((gpointer) e->file_name, "changed", G_CALLBACK(on_entries_changed), e);
+    g_signal_connect((gpointer) e->base_path, "changed", G_CALLBACK(on_entries_changed), e);
 
-	gtk_widget_show_all(e->dialog);
+    gtk_widget_show_all(e->dialog);
 
-	retry:
-	response = gtk_dialog_run(GTK_DIALOG(e->dialog));
-	if (response == GTK_RESPONSE_OK)
-		if (! update_config(e))
-			goto retry;
+    retry:
+    response = gtk_dialog_run(GTK_DIALOG(e->dialog));
+    if (response == GTK_RESPONSE_OK)
+        if (! update_config(e))
+            goto retry;
 
-	gtk_widget_destroy(e->dialog);
-	g_free(e);
+    gtk_widget_destroy(e->dialog);
+    g_free(e);
 }
 
 
 #ifndef G_OS_WIN32
 static void run_open_dialog(GtkDialog *dialog)
 {
-	gint response;
+    gint response;
 
-	retry:
-	response = gtk_dialog_run(dialog);
+    retry:
+    response = gtk_dialog_run(dialog);
 
-	if (response == GTK_RESPONSE_ACCEPT)
-	{
-		gchar *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
+    if (response == GTK_RESPONSE_ACCEPT)
+    {
+        gchar *filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
 
-		// try to load the config
-		if (! project_load_file(filename))
-		{
-			gchar *utf8_filename = utils_get_utf8_from_locale(filename);
+        // try to load the config
+        if (! project_load_file(filename))
+        {
+            gchar *utf8_filename = utils_get_utf8_from_locale(filename);
 
-			SHOW_ERR1(_("Project file \"%s\" could not be loaded."), utf8_filename);
-			gtk_widget_grab_focus(GTK_WIDGET(dialog));
-			g_free(utf8_filename);
-			g_free(filename);
-			goto retry;
-		}
-		g_free(filename);
-	}
+            SHOW_ERR1(_("Project file \"%s\" could not be loaded."), utf8_filename);
+            gtk_widget_grab_focus(GTK_WIDGET(dialog));
+            g_free(utf8_filename);
+            g_free(filename);
+            goto retry;
+        }
+        g_free(filename);
+    }
 }
 #endif
 
 
 void project_open()
 {
-	const gchar *dir = local_prefs.project_file_path;
+    const gchar *dir = local_prefs.project_file_path;
 #ifdef G_OS_WIN32
-	gchar *file;
+    gchar *file;
 #else
-	GtkWidget *dialog;
-	GtkFileFilter *filter;
-	gchar *locale_path;
+    GtkWidget *dialog;
+    GtkFileFilter *filter;
+    gchar *locale_path;
 #endif
-	if (! close_open_project()) return;
+    if (! close_open_project()) return;
 
 #ifdef G_OS_WIN32
-	file = win32_show_project_open_dialog(_("Open Project"), dir, FALSE);
-	if (file != NULL)
-	{
-		load_config(file);
-		g_free(file);
-	}
+    file = win32_show_project_open_dialog(_("Open Project"), dir, FALSE);
+    if (file != NULL)
+    {
+        load_config(file);
+        g_free(file);
+    }
 #else
 
-	dialog = gtk_file_chooser_dialog_new(_("Open Project"), GTK_WINDOW(app->window),
-			GTK_FILE_CHOOSER_ACTION_OPEN,
-			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
-			GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
-	gtk_widget_set_name(dialog, "GeanyDialogProject");
+    dialog = gtk_file_chooser_dialog_new(_("Open Project"), GTK_WINDOW(app->window),
+            GTK_FILE_CHOOSER_ACTION_OPEN,
+            GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
+            GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, NULL);
+    gtk_widget_set_name(dialog, "GeanyDialogProject");
 
-	// set default Open, so pressing enter can open multiple files
-	gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
-	gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
-	gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
-	gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(app->window));
-	gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(dialog), TRUE);
+    // set default Open, so pressing enter can open multiple files
+    gtk_dialog_set_default_response(GTK_DIALOG(dialog), GTK_RESPONSE_ACCEPT);
+    gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);
+    gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
+    gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(app->window));
+    gtk_file_chooser_set_select_multiple(GTK_FILE_CHOOSER(dialog), TRUE);
 
-	// add FileFilters
-	filter = gtk_file_filter_new();
-	gtk_file_filter_set_name(filter, _("All files"));
-	gtk_file_filter_add_pattern(filter, "*");
-	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
-	filter = gtk_file_filter_new();
-	gtk_file_filter_set_name(filter, _("Project files"));
-	gtk_file_filter_add_pattern(filter, "*." GEANY_PROJECT_EXT);
-	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
-	gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(dialog), filter);
+    // add FileFilters
+    filter = gtk_file_filter_new();
+    gtk_file_filter_set_name(filter, _("All files"));
+    gtk_file_filter_add_pattern(filter, "*");
+    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
+    filter = gtk_file_filter_new();
+    gtk_file_filter_set_name(filter, _("Project files"));
+    gtk_file_filter_add_pattern(filter, "*." GEANY_PROJECT_EXT);
+    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog), filter);
+    gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(dialog), filter);
 
-	locale_path = utils_get_locale_from_utf8(dir);
-	if (g_file_test(locale_path, G_FILE_TEST_EXISTS) &&
-		g_file_test(locale_path, G_FILE_TEST_IS_DIR))
-	{
-		gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), locale_path);
-	}
-	g_free(locale_path);
+    locale_path = utils_get_locale_from_utf8(dir);
+    if (g_file_test(locale_path, G_FILE_TEST_EXISTS) &&
+        g_file_test(locale_path, G_FILE_TEST_IS_DIR))
+    {
+        gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(dialog), locale_path);
+    }
+    g_free(locale_path);
 
-	gtk_widget_show_all(dialog);
-	run_open_dialog(GTK_DIALOG(dialog));
-	gtk_widget_destroy(GTK_WIDGET(dialog));
+    gtk_widget_show_all(dialog);
+    run_open_dialog(GTK_DIALOG(dialog));
+    gtk_widget_destroy(GTK_WIDGET(dialog));
 #endif
+    configuration_open_files(); // Load the session files into the tabs
 }
 
 
 // Called when opening, closing and updating projects.
 static void update_ui()
 {
-	ui_set_window_title(-1);
-	build_menu_update(-1);
+    ui_set_window_title(-1);
+    build_menu_update(-1);
 }
 
+void project_save()
+{
+    g_return_if_fail(app->project != NULL);
+    
+    write_config();
+    
+    ui_set_statusbar(TRUE, _("Project \"%s\" saved."), app->project->name);
+}
 
 void project_close()
 {
-	g_return_if_fail(app->project != NULL);
+    gint i, max = gtk_notebook_get_n_pages(GTK_NOTEBOOK(app->notebook));
+    g_return_if_fail(app->project != NULL);
 
-	/// TODO handle open project files
+    /// TODO handle open project files
+   
+    ui_set_statusbar(TRUE, _("Project \"%s\" closed."), app->project->name);
 
-	write_config();
-	ui_set_statusbar(TRUE, _("Project \"%s\" closed."), app->project->name);
+    g_free(app->project->name);
+    g_free(app->project->description);
+    g_free(app->project->file_name);
+    g_free(app->project->base_path);
+    g_free(app->project->run_cmd);
 
-	g_free(app->project->name);
-	g_free(app->project->description);
-	g_free(app->project->file_name);
-	g_free(app->project->base_path);
-	g_free(app->project->run_cmd);
+    g_free(app->project);
+    app->project = NULL;
 
-	g_free(app->project);
-	app->project = NULL;
+    for(i = 0; i < max; i++)
+        if (! document_remove(0))
+            break;
+            
+    tm_workspace_update(TM_WORK_OBJECT(app->tm_workspace), TRUE, TRUE, FALSE);
 
-	update_ui();
+    update_ui();
 }
 
 
 void project_properties()
 {
-	GtkWidget *vbox;
-	GtkWidget *table;
-	GtkWidget *image;
-	GtkWidget *button;
-	GtkWidget *bbox;
-	GtkWidget *label;
-	GtkWidget *swin;
-	GtkTooltips *tooltips = GTK_TOOLTIPS(lookup_widget(app->window, "tooltips"));
-	PropertyDialogElements *e = g_new(PropertyDialogElements, 1);
-	GeanyProject *p = app->project;
-	gint response;
+    GtkWidget *vbox;
+    GtkWidget *table;
+    GtkWidget *image;
+    GtkWidget *button;
+    GtkWidget *bbox;
+    GtkWidget *label;
+    GtkWidget *swin;
+    GtkTooltips *tooltips = GTK_TOOLTIPS(lookup_widget(app->window, "tooltips"));
+    PropertyDialogElements *e = g_new(PropertyDialogElements, 1);
+    GeanyProject *p = app->project;
+    gint response;
 
-	g_return_if_fail(app->project != NULL);
+    g_return_if_fail(app->project != NULL);
 
-	e->dialog = gtk_dialog_new_with_buttons(_("Project Properties"), GTK_WINDOW(app->window),
-										 GTK_DIALOG_DESTROY_WITH_PARENT,
-										 GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
-	gtk_dialog_add_buttons(GTK_DIALOG(e->dialog), GTK_STOCK_OK, GTK_RESPONSE_OK, NULL);
-	gtk_widget_set_name(e->dialog, "GeanyDialogProject");
+    e->dialog = gtk_dialog_new_with_buttons(_("Project Properties"), GTK_WINDOW(app->window),
+                                         GTK_DIALOG_DESTROY_WITH_PARENT,
+                                         GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
+    gtk_dialog_add_buttons(GTK_DIALOG(e->dialog), GTK_STOCK_OK, GTK_RESPONSE_OK, NULL);
+    gtk_widget_set_name(e->dialog, "GeanyDialogProject");
 
-	vbox = ui_dialog_vbox_new(GTK_DIALOG(e->dialog));
+    vbox = ui_dialog_vbox_new(GTK_DIALOG(e->dialog));
 
-	entries_modified = FALSE;
+    entries_modified = FALSE;
 
-	table = gtk_table_new(6, 2, FALSE);
-	gtk_table_set_row_spacings(GTK_TABLE(table), 5);
-	gtk_table_set_col_spacings(GTK_TABLE(table), 10);
+    table = gtk_table_new(6, 2, FALSE);
+    gtk_table_set_row_spacings(GTK_TABLE(table), 5);
+    gtk_table_set_col_spacings(GTK_TABLE(table), 10);
 
-	label = gtk_label_new(_("Name:"));
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Name:"));
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->name = gtk_entry_new();
-	gtk_entry_set_max_length(GTK_ENTRY(e->name), MAX_NAME_LEN);
-	gtk_table_attach(GTK_TABLE(table), e->name, 1, 2, 0, 1,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->name = gtk_entry_new();
+    gtk_entry_set_max_length(GTK_ENTRY(e->name), MAX_NAME_LEN);
+    gtk_table_attach(GTK_TABLE(table), e->name, 1, 2, 0, 1,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 
-	label = gtk_label_new(_("Filename:"));
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Filename:"));
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 1, 2,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->file_name = gtk_entry_new();
-	gtk_editable_set_editable(GTK_EDITABLE(e->file_name), FALSE);	// read-only
-	gtk_table_attach(GTK_TABLE(table), e->file_name, 1, 2, 1, 2,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->file_name = gtk_entry_new();
+    gtk_editable_set_editable(GTK_EDITABLE(e->file_name), FALSE);   // read-only
+    gtk_table_attach(GTK_TABLE(table), e->file_name, 1, 2, 1, 2,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 
-	label = gtk_label_new(_("Description:"));
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (GTK_FILL), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Description:"));
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 2, 3,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (GTK_FILL), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->description = gtk_text_view_new();
-	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(e->description), GTK_WRAP_WORD);
-	swin = gtk_scrolled_window_new(NULL, NULL);
-	gtk_widget_set_size_request(swin, 250, 80);
-	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
-				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
-	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(swin), GTK_WIDGET(e->description));
-	gtk_table_attach(GTK_TABLE(table), swin, 1, 2, 2, 3,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->description = gtk_text_view_new();
+    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(e->description), GTK_WRAP_WORD);
+    swin = gtk_scrolled_window_new(NULL, NULL);
+    gtk_widget_set_size_request(swin, 250, 80);
+    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
+                GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
+    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(swin), GTK_WIDGET(e->description));
+    gtk_table_attach(GTK_TABLE(table), swin, 1, 2, 2, 3,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 
-	label = gtk_label_new(_("Base path:"));
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 3, 4,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Base path:"));
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 3, 4,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->base_path = gtk_entry_new();
-	gtk_tooltips_set_tip(tooltips, e->base_path,
-		_("Base directory of all files that make up the project. "
-		"This can be a new path, or an existing directory tree absolute "
-		"or relative to the project filename."), NULL);
-	bbox = ui_path_box_new(_("Choose Project Base Path"),
-		GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(e->base_path));
-	gtk_table_attach(GTK_TABLE(table), bbox, 1, 2, 3, 4,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->base_path = gtk_entry_new();
+    gtk_tooltips_set_tip(tooltips, e->base_path,
+        _("Base directory of all files that make up the project. "
+        "This can be a new path, or an existing directory tree absolute "
+        "or relative to the project filename."), NULL);
+    bbox = ui_path_box_new(_("Choose Project Base Path"),
+        GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, GTK_ENTRY(e->base_path));
+    gtk_table_attach(GTK_TABLE(table), bbox, 1, 2, 3, 4,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 
-	label = gtk_label_new(_("Run command:"));
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 4, 5,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("Run command:"));
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 4, 5,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->run_cmd = gtk_entry_new();
-	gtk_tooltips_set_tip(tooltips, e->run_cmd,
-		_("Command-line to run in the project base directory. "
-		"Options can be appended to the command. "
-		"Leave blank to use the default run command."), NULL);
-	button = gtk_button_new();
-	g_signal_connect((gpointer) button, "clicked",
-				G_CALLBACK(on_file_open_button_clicked), e->run_cmd);
-	image = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_BUTTON);
-	gtk_container_add(GTK_CONTAINER(button), image);
-	bbox = gtk_hbox_new(FALSE, 6);
-	gtk_box_pack_start_defaults(GTK_BOX(bbox), e->run_cmd);
-	gtk_box_pack_start(GTK_BOX(bbox), button, FALSE, FALSE, 0);
-	gtk_table_attach(GTK_TABLE(table), bbox, 1, 2, 4, 5,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->run_cmd = gtk_entry_new();
+    gtk_tooltips_set_tip(tooltips, e->run_cmd,
+        _("Command-line to run in the project base directory. "
+        "Options can be appended to the command. "
+        "Leave blank to use the default run command."), NULL);
+    button = gtk_button_new();
+    g_signal_connect((gpointer) button, "clicked",
+                G_CALLBACK(on_file_open_button_clicked), e->run_cmd);
+    image = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_BUTTON);
+    gtk_container_add(GTK_CONTAINER(button), image);
+    bbox = gtk_hbox_new(FALSE, 6);
+    gtk_box_pack_start_defaults(GTK_BOX(bbox), e->run_cmd);
+    gtk_box_pack_start(GTK_BOX(bbox), button, FALSE, FALSE, 0);
+    gtk_table_attach(GTK_TABLE(table), bbox, 1, 2, 4, 5,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 
 #if 0
-	label = gtk_label_new(_("File patterns:"));
-	// <small>Separate multiple patterns by a new line</small>
-	gtk_table_attach(GTK_TABLE(table), label, 0, 1, 5, 6,
-					(GtkAttachOptions) (GTK_FILL),
-					(GtkAttachOptions) (GTK_FILL), 0, 0);
-	gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
+    label = gtk_label_new(_("File patterns:"));
+    // <small>Separate multiple patterns by a new line</small>
+    gtk_table_attach(GTK_TABLE(table), label, 0, 1, 5, 6,
+                    (GtkAttachOptions) (GTK_FILL),
+                    (GtkAttachOptions) (GTK_FILL), 0, 0);
+    gtk_misc_set_alignment(GTK_MISC(label), 1, 0);
 
-	e->patterns = gtk_text_view_new();
-	swin = gtk_scrolled_window_new(NULL, NULL);
-	gtk_widget_set_size_request(swin, -1, 80);
-	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
-				GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
-	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(swin), GTK_WIDGET(e->patterns));
-	gtk_table_attach(GTK_TABLE(table), swin, 1, 2, 5, 6,
-					(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
-					(GtkAttachOptions) (0), 0, 0);
+    e->patterns = gtk_text_view_new();
+    swin = gtk_scrolled_window_new(NULL, NULL);
+    gtk_widget_set_size_request(swin, -1, 80);
+    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swin),
+                GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
+    gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(swin), GTK_WIDGET(e->patterns));
+    gtk_table_attach(GTK_TABLE(table), swin, 1, 2, 5, 6,
+                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
+                    (GtkAttachOptions) (0), 0, 0);
 #endif
 
-	gtk_container_add(GTK_CONTAINER(vbox), table);
+    gtk_container_add(GTK_CONTAINER(vbox), table);
 
-	// fill the elements with the appropriate data
-	gtk_entry_set_text(GTK_ENTRY(e->name), p->name);
+    // fill the elements with the appropriate data
+    gtk_entry_set_text(GTK_ENTRY(e->name), p->name);
 
-	if (p->description != NULL)
-	{	// set text
-		GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->description));
-		gtk_text_buffer_set_text(buffer, p->description, -1);
-	}
+    if (p->description != NULL)
+    {   // set text
+        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->description));
+        gtk_text_buffer_set_text(buffer, p->description, -1);
+    }
 
 #if 0
-	if (p->file_patterns != NULL)
-	{	// set the file patterns
-		gint i;
-		gint len = g_strv_length(p->file_patterns);
-		GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->patterns));
-		GString *str = g_string_sized_new(len * 4);
+    if (p->file_patterns != NULL)
+    {   // set the file patterns
+        gint i;
+        gint len = g_strv_length(p->file_patterns);
+        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(e->patterns));
+        GString *str = g_string_sized_new(len * 4);
 
-		for (i = 0; i < len; i++)
-		{
-			if (p->file_patterns[i] != NULL)
-			{
-				g_string_append(str, p->file_patterns[i]);
-				g_string_append_c(str, '\n');
-			}
-		}
-		gtk_text_buffer_set_text(buffer, str->str, -1);
-		g_string_free(str, TRUE);
-	}
+        for (i = 0; i < len; i++)
+        {
+            if (p->file_patterns[i] != NULL)
+            {
+                g_string_append(str, p->file_patterns[i]);
+                g_string_append_c(str, '\n');
+            }
+        }
+        gtk_text_buffer_set_text(buffer, str->str, -1);
+        g_string_free(str, TRUE);
+    }
 #endif
 
-	gtk_entry_set_text(GTK_ENTRY(e->file_name), p->file_name);
-	gtk_entry_set_text(GTK_ENTRY(e->base_path), p->base_path);
-	if (p->run_cmd != NULL)
-		gtk_entry_set_text(GTK_ENTRY(e->run_cmd), p->run_cmd);
+    gtk_entry_set_text(GTK_ENTRY(e->file_name), p->file_name);
+    gtk_entry_set_text(GTK_ENTRY(e->base_path), p->base_path);
+    if (p->run_cmd != NULL)
+        gtk_entry_set_text(GTK_ENTRY(e->run_cmd), p->run_cmd);
 
-	gtk_widget_show_all(e->dialog);
+    gtk_widget_show_all(e->dialog);
 
-	retry:
-	response = gtk_dialog_run(GTK_DIALOG(e->dialog));
-	if (response == GTK_RESPONSE_OK)
-	{
-		if (! update_config(e))
-			goto retry;
-		// successfully updated properties
-		update_ui();
-	}
+    retry:
+    response = gtk_dialog_run(GTK_DIALOG(e->dialog));
+    if (response == GTK_RESPONSE_OK)
+    {
+        if (! update_config(e))
+            goto retry;
+        // successfully updated properties
+        update_ui();
+    }
 
-	gtk_widget_destroy(e->dialog);
-	g_free(e);
+    gtk_widget_destroy(e->dialog);
+    g_free(e);
 }
 
 
@@ -493,20 +508,20 @@
  * and TRUE if we can go ahead */
 static gboolean close_open_project()
 {
-	if (app->project != NULL)
-	{
-		if (dialogs_show_question_full(NULL, GTK_STOCK_OK, GTK_STOCK_CANCEL,
-			_("Do you want to close it before proceeding?"),
-			_("The '%s' project is already open. "), app->project->name))
-		{
-			project_close();
-			return TRUE;
-		}
-		else
-			return FALSE;
-	}
-	else
-		return TRUE;
+    if (app->project != NULL)
+    {
+        if (dialogs_show_question_full(NULL, GTK_STOCK_OK, GTK_STOCK_CANCEL,
+            _("Do you want to close it before proceeding?"),
+            _("The '%s' project is already open. "), app->project->name))
+        {
+            project_close();
+            return TRUE;
+        }
+        else
+            return FALSE;
+    }
+    else
+        return TRUE;
 }
 
 
